import { ExtractPropTypes, PropType, DefineComponent, CSSProperties, Ref } from "vue";
import { ElCol } from "element-plus";
import { HTMLElementDeprecatedTagNameMap, HTMLElementTagNameMap, SVGElementTagNameMap, ElNodeName, ElementProps } from "@tomiaa/utils";
import { Editor, Toolbar } from "@wangeditor/editor-for-vue";
import KForm from "..";
export declare const formProps: {
    readonly modelValue: {
        readonly type: BooleanConstructor;
        readonly default: undefined;
        readonly required: false;
    };
    readonly showActions: {
        readonly type: BooleanConstructor;
        readonly default: true;
    };
    readonly actionsConfig: {
        readonly type: PropType<ActionsConfig>;
        readonly default: () => {};
    };
    readonly options: {
        readonly type: PropType<FormOptions[]>;
        readonly default: () => never[];
    };
    readonly model: {
        readonly type: ObjectConstructor;
        readonly default: () => {};
    };
    readonly autoValidateOnSubmit: {
        readonly type: BooleanConstructor;
        readonly default: true;
    };
    readonly appendToBody: import("element-plus/es/utils").EpPropFinalized<BooleanConstructor, unknown, unknown, false, boolean>;
    readonly beforeClose: {
        readonly type: PropType<import("element-plus").DialogBeforeCloseFn>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    readonly destroyOnClose: import("element-plus/es/utils").EpPropFinalized<BooleanConstructor, unknown, unknown, false, boolean>;
    readonly closeOnClickModal: import("element-plus/es/utils").EpPropFinalized<BooleanConstructor, unknown, unknown, true, boolean>;
    readonly closeOnPressEscape: import("element-plus/es/utils").EpPropFinalized<BooleanConstructor, unknown, unknown, true, boolean>;
    readonly lockScroll: import("element-plus/es/utils").EpPropFinalized<BooleanConstructor, unknown, unknown, true, boolean>;
    readonly modal: import("element-plus/es/utils").EpPropFinalized<BooleanConstructor, unknown, unknown, true, boolean>;
    readonly openDelay: import("element-plus/es/utils").EpPropFinalized<NumberConstructor, unknown, unknown, 0, boolean>;
    readonly closeDelay: import("element-plus/es/utils").EpPropFinalized<NumberConstructor, unknown, unknown, 0, boolean>;
    readonly top: {
        readonly type: PropType<string>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    readonly modalClass: StringConstructor;
    readonly width: {
        readonly type: PropType<import("element-plus/es/utils").EpPropMergeType<readonly [StringConstructor, NumberConstructor], unknown, unknown>>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    readonly zIndex: {
        readonly type: PropType<number>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    readonly trapFocus: import("element-plus/es/utils").EpPropFinalized<BooleanConstructor, unknown, unknown, false, boolean>;
    readonly center: import("element-plus/es/utils").EpPropFinalized<BooleanConstructor, unknown, unknown, false, boolean>;
    readonly alignCenter: import("element-plus/es/utils").EpPropFinalized<BooleanConstructor, unknown, unknown, false, boolean>;
    readonly closeIcon: {
        readonly type: PropType<import("element-plus/es/utils").EpPropMergeType<(new (...args: any[]) => (string | import("vue").Component<any, any, any, import("vue").ComputedOptions, import("vue").MethodOptions>) & {}) | (() => string | import("vue").Component<any, any, any, import("vue").ComputedOptions, import("vue").MethodOptions>) | ((new (...args: any[]) => (string | import("vue").Component<any, any, any, import("vue").ComputedOptions, import("vue").MethodOptions>) & {}) | (() => string | import("vue").Component<any, any, any, import("vue").ComputedOptions, import("vue").MethodOptions>))[], unknown, unknown>>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    readonly customClass: import("element-plus/es/utils").EpPropFinalized<StringConstructor, unknown, unknown, "", boolean>;
    readonly draggable: import("element-plus/es/utils").EpPropFinalized<BooleanConstructor, unknown, unknown, false, boolean>;
    readonly fullscreen: import("element-plus/es/utils").EpPropFinalized<BooleanConstructor, unknown, unknown, false, boolean>;
    readonly showClose: import("element-plus/es/utils").EpPropFinalized<BooleanConstructor, unknown, unknown, true, boolean>;
    readonly title: import("element-plus/es/utils").EpPropFinalized<StringConstructor, unknown, unknown, "", boolean>;
};
declare type ActionsConfig = {
    showCancel?: boolean;
    cancelText?: string;
    showReset?: boolean;
    resetText?: string;
    showSubmit?: boolean;
    submitText?: string;
    custom?: (list: {
        [prop: string]: any;
    }[]) => {
        [prop: string]: any;
    }[];
} & Pick<InstanceType<typeof ElCol>["$props"]>;
declare type OmitBaseProps<T> = Omit<T, keyof InstanceType<DefineComponent>["$props"]>;
declare type Pick<T> = {
    [P in keyof OmitBaseProps<T>]?: any;
};
export declare type FormOptions = DefineComponent | (ElementProps & {
    [prop: string | number | symbol]: any;
    el?: ElNodeName | "editor" | keyof HTMLElementDeprecatedTagNameMap | keyof HTMLElementTagNameMap | keyof SVGElementTagNameMap | (string & {}) | {
        [prop: string | number | symbol]: any;
    };
    editorAttrs?: Pick<InstanceType<typeof Editor>["$props"]>;
    toolbarAttrs?: Pick<InstanceType<typeof Toolbar>["$props"]>;
    style?: CSSProperties;
    children?: FormOptions | FormOptions[] | DefineComponent | DefineComponent[] | string | Ref<any>;
    slot?: string;
    deepSlot?: string;
});
export declare type FormProps = ExtractPropTypes<typeof formProps>;
export declare const formEmits: {
    submit: null;
    reset: null;
    cancel: null;
    submitCheckFail: null;
    "update:model": null;
    open: () => boolean;
    opened: () => boolean;
    close: () => boolean;
    closed: () => boolean;
    "update:modelValue": (value: boolean) => boolean;
    openAutoFocus: () => boolean;
    closeAutoFocus: () => boolean;
};
export declare type FormEmits = ExtractPropTypes<typeof formEmits>;
export declare type FormInstance = InstanceType<typeof KForm>;
export {};
