import { ExtractPropTypes, PropType } from "vue";
export interface NotificationListItem {
    avatar?: string;
    title?: string;
    desc?: string;
    time?: string;
    tag?: string;
    tagType?: "" | "success" | "info" | "warning" | "danger";
}
export interface NotificationListOptions {
    title: string;
    content: NotificationListItem[];
}
export interface NotificationActionOptions {
    text: string;
    icon?: string;
}
export declare const notificationProps: {
    readonly icon: {
        readonly type: StringConstructor;
        readonly default: "ElIconBell";
    };
    readonly value: PropType<string | number>;
    readonly max: NumberConstructor;
    readonly isDot: BooleanConstructor;
    readonly list: {
        readonly type: PropType<NotificationListOptions[]>;
        readonly required: true;
    };
    readonly actions: PropType<NotificationActionOptions[]>;
};
export declare type NotificationProps = ExtractPropTypes<typeof notificationProps>;
export declare type NotificationEmits = {
    clickItem: (arg: {
        item: NotificationListItem;
        index: number;
    }) => void;
    clickAction: (arg: {
        item: NotificationActionOptions;
        index: number;
    }) => void;
};
