import { ExtractPropTypes } from "vue";
interface DataType {
    code: string;
    name: string;
}
export interface SelectAreaItem extends DataType {
    children?: SelectAreaItem[];
}
/**
 * change 事件: 省 市 区
 */
interface SelectAreaChange {
    provinceData: DataType;
    cityData: DataType;
    areaData: DataType;
}
/**
 * 事件
 */
export declare type SelectAreaEmits = {
    change(data: SelectAreaChange): void;
};
/**
 * 属性
 */
export declare const selectAreaProps: {
    readonly provinceAttrs: ObjectConstructor;
    readonly cityAttrs: ObjectConstructor;
    readonly areaAttrs: ObjectConstructor;
};
/**
 * 属性
 */
export declare type SelectAreaProps = ExtractPropTypes<typeof selectAreaProps>;
export {};
