import { PropType, ExtractPropTypes } from "vue";
export declare const selectDateProps: {
    readonly startDate: {
        readonly type: PropType<string | number | Date>;
        readonly required: true;
    };
    readonly endDate: {
        readonly type: PropType<string | number | Date>;
        readonly required: true;
    };
    readonly startDatePlaceholder: {
        readonly type: StringConstructor;
        readonly default: "请选择开始日期";
    };
    readonly endDatePlaceholder: {
        readonly type: StringConstructor;
        readonly default: "请选择结束日期";
    };
    readonly enTimeDisabled: BooleanConstructor;
    readonly valueFormat: StringConstructor;
    readonly format: StringConstructor;
    readonly type: PropType<"year" | "month" | "date" | "dates" | "datetime" | "week" | "datetimerange" | "daterange" | "monthrange">;
    readonly startDateAttrs: ObjectConstructor;
    readonly endDateAttrs: ObjectConstructor;
};
export declare type SelectDateProps = ExtractPropTypes<typeof selectDateProps>;
